/*******************************************************************************
 * This software is copyright (c) 2017 by
 *
 *   TextGrid Consortium (http://www.textgrid.de)
 *
 * This is free software. You can redistribute it and/or modify it under the
 * terms described in the GNU Lesser General Public License v3 of which you
 * should have received a copy. Otherwise you can download it from
 *
 *   http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 * @copyright TextGrid Consortium (http://www.textgrid.de)
 * @copyright SUB Göttingen (http://www.sub.uni-goettingen.de)
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public
 * License v3
 * @author Stefan E. Funk (funk@sub.uni-goettingen.de)
 ******************************************************************************/

package info.textgrid.middleware.tgauth.tgauthclient;

import info.textgrid.namespaces.middleware.tgauth_crud.PortTgextraCrud;
import info.textgrid.namespaces.middleware.tgauth_crud.TgextraCrud;

import java.net.URL;
import java.util.Map;

import javax.xml.ws.BindingProvider;

/*******************************************************************************
 * TODOLOG
 *
 *******************************************************************************
 * CHANGELOG
 *
 * 2016-08-03    Funk    Copied from TGAuthClientUtilities.
 ******************************************************************************/

/*******************************************************************************
 * <p>
 * TG-auth CRUD client utility class to get appropriate TG-auth clients.
 * </p>
 *
 * @author Stefan E. Funk, SUB Göttingen
 * @version 2017-07-21
 * @since 2016-08-03
 ******************************************************************************/

public final class TGAuthClientCrudUtilities {

	/**
	 * PRIVATE CONSRUCTOR FOR STATIC CLASS
	 */
	private TGAuthClientCrudUtilities() {
		//
	}

	// **
	// MAIN CLASS
	// **

	/**
	 * <p>
	 * Creates a TG-extra CRUD stub.
	 * </p>
	 * 
	 * @param theEndpoint
	 * @return A TgextraCrud service port.
	 */
	public static PortTgextraCrud getTgextraCrud(URL theEndpoint) {

		// Create TG-extra service stubs.
		TgextraCrud tgextraCrud = new TgextraCrud((URL) null);
		PortTgextraCrud portTgextraCrud = tgextraCrud
				.getPort(PortTgextraCrud.class);
		BindingProvider bindingProvider = (BindingProvider) portTgextraCrud;
		Map<String, Object> requestContext = bindingProvider
				.getRequestContext();
		requestContext.put(BindingProvider.ENDPOINT_ADDRESS_PROPERTY,
				theEndpoint.toString());

		return portTgextraCrud;
	}

}
