/*******************************************************************************
 * This software is copyright (c) 2018 by
 *
 *   TextGrid Consortium (http://www.textgrid.de)
 *
 * This is free software. You can redistribute it and/or modify it under the
 * terms described in the GNU Lesser General Public License v3 of which you
 * should have received a copy. Otherwise you can download it from
 *
 *   http://www.gnu.org/licenses/lgpl-3.0.txt
 *
 * @copyright TextGrid Consortium (http://www.textgrid.de)
 * @copyright SUB Göttingen (http://www.sub.uni-goettingen.de)
 * @license http://www.gnu.org/licenses/lgpl-3.0.txt GNU Lesser General Public
 * License v3
 * @author Stefan E. Funk (funk@sub.uni-goettingen.de)
 ******************************************************************************/

package info.textgrid.middleware.tgauth.tgauthclient;

import java.net.MalformedURLException;
import java.net.URL;

import javax.xml.ws.soap.SOAPFaultException;

import info.textgrid.namespaces.middleware.tgauth_crud.AuthenticationFault;
import info.textgrid.namespaces.middleware.tgauth_crud.PortTgextraCrud;
import info.textgrid.namespaces.middleware.tgauth_crud.TgCrudCheckAccessRequest;
import info.textgrid.namespaces.middleware.tgauth_crud.TgCrudCheckAccessResponse;
import info.textgrid.namespaces.middleware.tgauth_crud.UnknownResourceFault;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Ignore;
import org.junit.Test;

/*******************************************************************************
 * TODOLOG
 *
 *******************************************************************************
 * CHANGELOG
 *
 * 2016-08-03    Funk    Copied from TGAuthClientUtilities.
 ******************************************************************************/

/*******************************************************************************
 * <p>
 * TG-auth CRUD client utility class to get appropriate TG-auth clients.
 * </p>
 *
 * @author Stefan E. Funk, SUB Göttingen
 * @version 2018-03-06
 * @since 2016-08-04
 ******************************************************************************/

public final class TestTGAuthClientCrudUtilities {

	/**
	 * @throws Exception
	 */
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@Before
	public void setUp() throws Exception {
	}

	/**
	 * @throws java.lang.Exception
	 */
	@After
	public void tearDown() throws Exception {
	}

	/**
	 * <p>
	 * Note: This is an online test, please enable if necessary!
	 * </p>
	 *
	 * @throws MalformedURLException
	 * @throws UnknownResourceFault
	 * @throws AuthenticationFault
	 */
	@Ignore
	@Test(expected = SOAPFaultException.class)
	public static void testGetTgextraCrud() throws MalformedURLException,
			UnknownResourceFault, AuthenticationFault {

		URL endpoint = new URL(
				"https://textgridlab.org/1.0/tgauth/tgextra-crud.php");

		PortTgextraCrud tgextraCrud = TGAuthClientCrudUtilities
				.getTgextraCrud(endpoint);

		TgCrudCheckAccessRequest request = new TgCrudCheckAccessRequest();
		request.setAuth("urgl");
		request.setLog("");
		request.setOperation("read");
		request.setResource("argl");
		request.setSecret("aua");

		TgCrudCheckAccessResponse response = tgextraCrud
				.tgCrudCheckAccess(request);

		System.out.println("response: " + response.isResult());
	}

}
